INTERPOLATE-NGRAM(1)

NAME
interpolate-ngram - interpolates n-gram language models

SYNOPSIS
interpolate-ngram [Options]

DESCRIPTION
Interpolates multiple n-gram models by computing appropriate interpolation weights from optional features and constructing a statically interpolated n-gram model. Parameters can be optionally tuned to optimize development set performance.

Filename argument can be an ASCII file, a compressed file (ending in .Z or .gz), or '-' to indicate stdin/stdout.

OPTIONS

-h, -help
    Print this message.

-verbose <int>
    Set verbosity level.

    Default: 1

-o, -order <int>
    Set the n-gram order of the estimated LM.

    Default: 3

-v, -vocab <file>
    Fix the vocab to only words from the specified file.

-u, -unk <boolean>
    Replace all out of vocab words with <unk>.

    Default: false

-l, -lm <file>
    Interpolate specified LM files.

-t, -text <files>
    Interpolate models trained from text files.

-c, -counts <files>
    Interpolate models trained from counts files.

-s, -smoothing <ML, FixKN, FixModKN, FixKN#, KN, ModKN, KN#>
    Specify smoothing algorithms.

    Default: ModKN

-wf, -weight-features <features-template>
    Specify n-gram weighting features.

-i, -interpolation <LI, CM, GLI>
    Specify interpolation mode.

    Default: LI

-if, -interpolation-features <features-template>
    Specify interpolation features.

-tpo, -tie-param-order <boolean>
    Tie parameters across n-gram order.

    Default: true

-tpl, -tie-param-lm <boolean>
    Tie parameters across LM components.

    Default: false

-p, -params <file>
    Set initial model params.

-oa, -opt-alg <Powell, LBFGS, LBFGSB>
    Specify optimization algorithm.

    Default: LBFGS

-op, -opt-perp <file>
    Tune params to minimize dev set perplexity.

-ow, -opt-wer <file>
    Tune params to minimize lattice word error rate.

-om, -opt-margin <file>
    Tune params to minimize lattice margin.

-wb, -write-binary <boolean>
    Write LM/counts files in binary format.

    Default: false

-wp, -write-params <file>
    Write tuned model params to file.

-wv, -write-vocab <file>
    Write LM vocab to file.

-wl, -write-lm <file>
    Write ARPA backoff LM to file.

-ep, -eval-perp <files>
    Compute test set perplexity.

-ew, -eval-wer <files>
    Compute test set lattice word error rate.

-em, -eval-margin <files>
    Compute test set lattice margin.

SEE ALSO
estimate-ngram(1), evaluate-ngram(1)